unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ShellAPI,
  StdCtrls, Menus, ExtCtrls, Buttons, ComCtrls, IniFiles, adCPUUsage, PortIO,
  VFD, PortIOVFD, Math, SysInfo, WinampControl, ScrollLabel, acpuid, InfoUnit;

type
   Longword = Cardinal;

// Konstanten fr SysBarIcon
const
  NIF_INFO = $10;
  NIF_MESSAGE = 1;
  NIF_ICON = 2;
  NOTIFYICON_VERSION = 3;
  NIF_TIP = 4;
  NIM_SETVERSION = $00000004;
  NIM_SETFOCUS = $00000003;
  NIIF_INFO = $00000001;
  NIIF_WARNING = $00000002;
  NIIF_ERROR = $00000003;
  NIN_BALLOONSHOW = WM_USER + 2;
  NIN_BALLOONHIDE = WM_USER + 3;
  NIN_BALLOONTIMEOUT = WM_USER + 4;
  NIN_BALLOONUSERCLICK = WM_USER + 5;
  NIN_SELECT = WM_USER + 0;
  NINF_KEY = $1;
  NIN_KEYSELECT = NIN_SELECT or NINF_KEY;
  //fr weitere Konstanten siehe vs.net -> vc7-Verzeichnis: PlatformSDK\Include\ShellAPI.h
  // Definition der CallbackMessage
  TRAY_CALLBACK = WM_USER + $7258;

  //new NotifyIconData Struktur-Definition}
type
  PNewNotifyIconData = ^TNewNotifyIconData;
  TDUMMYUNIONNAME    = record
    case Integer of
      0: (uTimeout: UINT);
      1: (uVersion: UINT);
  end;
  TNewNotifyIconData = record
    cbSize: DWORD;
    Wnd: HWND;
    uID: UINT;
    uFlags: UINT;
    uCallbackMessage: UINT;
    hIcon: HICON;
    szTip: array [0..127] of Char;
    dwState: DWORD;
    dwStateMask: DWORD;
    szInfo: array [0..255] of Char;
    DUMMYUNIONNAME: TDUMMYUNIONNAME;
    szInfoTitle: array [0..63] of Char;
    dwInfoFlags: DWORD;
  end;

//MainUnit-Typen

type
  TMainForm = class(TForm)
    PopupMenu: TPopupMenu;
    Exit1: TMenuItem;
    Show1: TMenuItem;
    HideTimer: TTimer;
    ExitButton: TBitBtn;
    OKButton: TBitBtn;
    DLPortIO: TDLPortIO;
    N1: TMenuItem;
    VFD: TPortIOVFD;
    ListTestButton: TButton;
    ListBox: TListBox;
    WaitTimer: TTimer;
    ExtListBox: TListBox;
    SysInfo: TSysInfo;
    InfoTimer: TTimer;
    FontLabel: TLabel;
    Winamp: TWinampControl;
    CPU: Tacpuid;
    NextButton: TButton;
    StopButton: TButton;
    SCR_Time_Label: TLabel;
    OpenDialog: TOpenDialog;
    ViewListPanel: TPanel;
    Bevel2: TBevel;
    Bevel1: TBevel;
    Bevel3: TBevel;
    Image1: TImage;
    Bevel4: TBevel;
    ExtraTimer: TTimer;
    UsageTimer: TTimer;
    PopupStopButton: TMenuItem;
    NchsterScreen1: TMenuItem;
    Listeladen1: TMenuItem;
    N2: TMenuItem;
    InfoButton: TBitBtn;
    OnlyOnIdleBox: TCheckBox;
    procedure Exit1Click(Sender: TObject);
    procedure Show1Click(Sender: TObject);
    procedure ExitButtonClick(Sender: TObject);
    procedure OKButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ListTestButtonClick(Sender: TObject);
    procedure WaitTimerTimer(Sender: TObject);
    procedure InfoTimerTimer(Sender: TObject);
    procedure NextButtonClick(Sender: TObject);
    procedure StopButtonClick(Sender: TObject);
    procedure ViewListPanelClick(Sender: TObject);
    procedure ExtraTimerTimer(Sender: TObject);
    procedure UsageTimerTimer(Sender: TObject);
    procedure PopupStopButtonClick(Sender: TObject);
    procedure NchsterScreen1Click(Sender: TObject);
    procedure Listeladen1Click(Sender: TObject);
    procedure InfoButtonClick(Sender: TObject);
    procedure OnlyOnIdleBoxClick(Sender: TObject);
    procedure OnlyOnIdleBoxKeyPress(Sender: TObject; var Key: Char);
    procedure HideTimerTimer(Sender: TObject);
  private
    IconData: TNewNotifyIconData;   //TaskBarIcon
    procedure WMSysCommand(var Message: TWMSysCommand); message WM_SysCommand;
    procedure SysTrayIconMsgHandler(var Msg: TMessage); message TRAY_CALLBACK;
    procedure AddSysTrayIcon;     //Fgt Icon in SystemTray hinzu
    procedure ShowBalloonTips;    //Zeigt Sprechblase
    procedure DeleteSysTrayIcon;  //Entfernt SysTray-Icon
    procedure Interprete(s:String);
    procedure CreateScreen;
    procedure BitmapToVFD(fname: string; XDisp,YDisp,Wdth, XOff: Word; Farbe: TColor);
    procedure LoadList(ListFileName: string);
    procedure InfoString(s: string; x,y: byte);
    procedure ClearInfoStrings;
    procedure RefreshInfos;
    procedure CharBar(Xa,Xe,Line:Byte;Percent:double); //Zeigt eine %-Bar an
    procedure showCPUMONITOR;
    procedure showCPUMONITORchar;
    procedure showRAMMONITOR;
    procedure showRAMMONITORchar;
    procedure showPrinterScreen;
    procedure showDrivesScreen;
    procedure ShowExtraScreens;  //vorgefertigte Screens mit Aktualisierung
    function averageCPUusage: single;
    function isIdle: Bool;
  public
    //Einstellungen aus der IniDatei
    LPTPort: word;                      // Portadresse
    ToDoList: string;                   // ListName
    //Fr Extratimer
    ShowTime,OverviewTime: integer;
  end;

type
  InfoString = record
   Info: string;
   X,Y: byte;
  end;


var
  MainForm: TMainForm;
  PosX, PosY: integer;  // Koordinaten fr Popupmen

  ListIndex: integer;   // Position in der ListBox

  InfoStrings: Array[0..7] of InfoString;  //Infos, die stndig aktualisiert werden mssen
  Fonted: Boolean;

  //fr Durchschnittliche CPU-Last
  CPUUsage: Array[0..449]of single;

  //fr CPU- & RAM-Monitor
  Cu, Mu: real;  //Usage in %
  RAMGraph: Array[0..252] of Byte;

  //ExtraScreens
  CPUMONITORenabled: Boolean;
  CPUMONITORcharEnabled: Boolean;
  RAMMONITORenabled: Boolean;
  RAMMONITORcharEnabled: Boolean;

  //betr. Animationen (abspielen nur wenn idle?)
  ScreenAnimated: Bool;  //enthlt der Screen berhaupt eine Animation?
  PlayOnlyOnIdle: Bool;  //nur abspielen, wenn Idle?
  IdleLevel: Integer;    //welche durschnittl. CPU-Last gilt noch als idle?
  IdleTime: Integer;     //ber welchen Zeitraum muss die durschnittl. CPU-Last idle sein?
  AnimationPaused: Bool;

  Drives: String;  //Liste der Laufwerke z.B. 'ACDF'
  DriveIndex: Integer; //aktueles Laufwerk (entspricht Position in obigen String)
implementation

{$R *.DFM}


//Die Funktionen aus der Drives.dll einbinden:
function GetFreeDiskSpace(Drive: char): double; external 'Drives.dll';
function GetDiskSpace(Drive: char): double; external 'Drives.dll';


procedure TMainForm.SysTrayIconMsgHandler(var Msg: TMessage);
var
   cp: TPoint;
begin
  // Ermitteln der aktuellen Cursorkoordinaten fr Popupmen
  getcursorpos(cp);
  PosX:=cp.x;
  PosY:=cp.y;
  try
  case Msg.lParam of
    WM_MOUSEMOVE:;
    WM_LBUTTONDOWN:;
    WM_LBUTTONUP:;
    WM_LBUTTONDBLCLK:;
    WM_RBUTTONDOWN:;
    WM_RBUTTONUP: mainform.PopupMenu.popup(PosX,PosY);
    WM_RBUTTONDBLCLK:;
    NIN_BALLOONSHOW:
    {Message wenn Sprechblase gezeigt wird}
      ShowMessage('NIN_BALLOONSHOW');
    NIN_BALLOONHIDE:
    {Message wenn die Sprechblase verschwindet (z.B. wenn das Icon entfernt wird).}
      ShowMessage('NIN_BALLOONHIDE');
    NIN_BALLOONTIMEOUT:
      ShowMessage('NIN_BALLOONTIMEOUT');
    NIN_BALLOONUSERCLICK:
      ShowMessage('NIN_BALLOONUSERCLICK');
  end
  except
  end;
end;

// AddSysTrayIcon fgt ein SysTrayIcon hinzu
procedure TMainForm.AddSysTrayIcon;
begin
  try
  IconData.cbSize := SizeOf(IconData);
  IconData.Wnd := AllocateHWnd(SysTrayIconMsgHandler);
  IconData.uID := 0;
  IconData.uFlags := NIF_ICON or NIF_MESSAGE or NIF_TIP;
  IconData.uCallbackMessage := TRAY_CALLBACK;
  IconData.hIcon := Application.Icon.Handle;    //IconHandle
  // Beschreibung, wenn man die Maus auf das Symbol bewegt
  IconData.szTip:='VFD-Studio';
  Shell_NotifyIcon(NIM_ADD, @IconData);  //Icon hinzufgen
  except
  end;
end;

{ShowBalloonTips zeigt die Sprechblase}
procedure TMainForm.ShowBalloonTips;
var
  TipInfo, TipTitle: string;
begin
  try
  IconData.cbSize := SizeOf(IconData);
  IconData.uFlags := NIF_INFO;

  TipInfo:='Liste: '+TodoList;
  strPLCopy(IconData.szInfo, TipInfo, SizeOf(IconData.szInfo) - 1);
  IconData.DUMMYUNIONNAME.uTimeout := 500;
  TipTitle := 'VFD-Studio';
  strPLCopy(IconData.szInfoTitle, TipTitle, SizeOf(IconData.szInfoTitle) - 1);
  IconData.dwInfoFlags := NIIF_INFO;     //NIIF_ERROR;  //NIIF_WARNING;
  Shell_NotifyIcon(NIM_MODIFY, @IconData);
  IconData.DUMMYUNIONNAME.uVersion := NOTIFYICON_VERSION;
  Shell_NotifyIcon(NIM_ADD, @IconData);
  except
  end;
end;

{Prozedur zum Entfernen}
procedure TMainForm.DeleteSysTrayIcon;
begin
  try
  DeallocateHWnd(IconData.Wnd);
  Shell_NotifyIcon(NIM_DELETE, @IconData);
  except
  end;
end;

// Beim Minimieren des Fensters hide, damit es nicht in der Taskbar auftaucht
procedure TMainForm.WMSysCommand(var Message: TWMSysCommand);
begin
  try
  if Message.CmdType and $FFF0 = SC_MINIMIZE then
    Hide
  else
    inherited;
  except
  end;
end;

procedure TMainForm.Exit1Click(Sender: TObject);
begin
     mainform.close;
end;

procedure TMainForm.Show1Click(Sender: TObject);
begin
     windowstate:=wsnormal;
     mainform.show;
end;

// HideTimer bewirkt, das Hide nicht sofort ausgefhrt wird, sondern erst nach kurzer Verz.
procedure TMainForm.ExitButtonClick(Sender: TObject);
begin
     mainform.close;
end;

procedure TMainForm.OKButtonClick(Sender: TObject);
begin
     hide;
end;


procedure TMainForm.FormCreate(Sender: TObject);
var
  VFDIni: TIniFile;
  IniName: string;
  i: integer;
begin


    //CPUusage initialisieren - '-1' wird als nicht gesetzter Wert interpretiert
    for i:=0 to 449 do
     cpuusage[i]:=-1;


    width:=260;


    try
    AddSysTrayIcon;
    IniName:=extractfilepath(application.ExeName)+'Vfd.ini';

    VFDIni := TIniFile.Create(IniName);
    with VFDIni do begin
       mainform.ShowTime:=ReadInteger('EXTRAS', 'ShowTime', 3000);
       mainform.OverviewTime:=ReadInteger('EXTRAS', 'OverviewTime', 6000);
       mainform.LPTPort:=ReadInteger('SETTINGS', 'Port', 888);
       mainform.ToDoList:=ReadString('LIST', 'Listname', '');
       PlayOnlyOnIdle:=ReadBool('ANIMATIONS', 'PlayOnlyOnIdle', false);
       IdleTime:=ReadInteger('ANIMATIONS', 'IdleTime', 45);
       IdleLevel:=ReadInteger('ANIMATIONS', 'IdleLevel', 25);
    end;

    vfd.PortIOComponent:=Dlportio;  //PortIO-Komponente fr VFD-Komponente zuweisen
    dlportio.DriverPath:=extractfilepath(application.exename);
    vfd.LPT:=mainform.LPTPort;           //LPT zuweisen

    VFDIni.Free;

    ShowBalloonTips;
    except
    end;

    OnlyOnIdleBox.Checked:=PlayOnlyOnIdle;


   try
   // der PortTreiber muss im selben Verzeichnis sein wie die exe
   DLPortIO.DriverPath:=ExtractFileDir(ParamStr(0));
   // Treiber ffnen
   DLPortIO.OpenDriver();
   if (not DLPortIO.ActiveHW) then
   begin
      MessageDlg('Konnte DriverLINX-Treiber nicht ffnen', mtError, [mbOK], 0);
   end;
  except
  end;

end;



procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  VFDIni: TIniFile;
  IniName: string;
begin
    vfd.SelectScreen(0);     //VFD abschalten bei Programmende  (Stromversorgung und Heizdrhte sind natrlich immer noch an!)
    IniName:=extractfilepath(application.ExeName)+'Vfd.ini';
    VFDIni := TIniFile.Create(IniName);
    with VFDIni do begin
       WriteInteger('SETTINGS', 'Port', mainform.LPTPort);
       WriteString('LIST', 'Listname',mainform.ToDoList);
       WriteBool('ANIMATIONS', 'PlayOnlyOnIdle', PlayOnlyOnIdle);
       WriteInteger('ANIMATIONS', 'IdleLevel', IdleLevel);
       WriteInteger('ANIMATIONS', 'IdleTime', IdleTime);
    end;
    VFDIni.Free;
    try
    dlportio.CloseDriver;
//    DeleteSysTrayIcon;
    except
    end;

     DeleteSysTrayIcon;
     application.Terminate;

end;

// Infos lschen
procedure TMainForm.ClearInfoStrings;
var
   i: Integer;
begin
     for i:=0 to 7 do Infostrings[i].Info:='';
end;

//Infos, die sich nicht stndig ndern
procedure TMainForm.InfoString(s: string; x,y: byte);
var
   i: Integer; //Index im String
begin

     while pos('$PCNAME$',s)<>0 do begin
      i:= pos('$PCNAME$',s);
      delete(s,i,length('$PCNAME$'));
      insert(sysinfo.computername,s,i);
     end;

     while pos('$USERNAME$',s)<>0 do begin
      i:= pos('$USERNAME$',s);
      delete(s,i,length('$USERNAME$'));
      insert(sysinfo.GetCurrentUserName,s,i);
     end;

     while pos('$MEMORY$',s)<>0 do begin
      i:= pos('$MEMORY$',s);
      delete(s,i,length('$MEMORY$'));
      insert(inttostr(round(sysinfo.GetTotalMemory / 1048576)),s,i);
     end;

     while pos('$OS$',s)<>0 do begin
      i:= pos('$OS$',s);
      delete(s,i,length('$OS$'));
      insert(sysinfo.GetOperatingSystem,s,i);
     end;

     while pos('$CPUSPEED$',s)<>0 do begin
      i:= pos('$CPUSPEED$',s);
      delete(s,i,length('$CPUSPEED$'));
      if sysinfo.GetCPUSpeed<>'unbekannt' then insert(sysinfo.GetCPUSpeed,s,i)
      else insert(inttostr(round(sysinfo.CalcCPUSpeed)),s,i);
     end;

     while pos('$CPUVENDOR$',s)<>0 do begin
      i:= pos('$CPUVENDOR$',s);
      delete(s,i,length('$CPUVENDOR$'));
      insert(sysinfo.GetCPUVendorIdentifier,s,i);
     end;

     while pos('$CPUNAME$',s)<>0 do begin
      i:= pos('$CPUNAME$',s);
      delete(s,i,length('$CPUNAME$'));
      insert(sysinfo.GetCPUName,s,i);
     end;

     while pos('$CPUIDENT$',s)<>0 do begin
      i:= pos('$CPUIDENT$',s);
      delete(s,i,length('$CPUIDENT$'));
      insert(sysinfo.GetCPUIdentifier,s,i);
     end;

     while pos('$CPUCLASS$',s)<>0 do begin
      i:= pos('$CPUCLASS$',s);
      delete(s,i,length('$CPUCLASS$'));
      insert('x'+inttostr(ord(cpu.CPUInfo.cpuClass))+'86',s,i);
     end;

     while pos('$CPUMODEL$',s)<>0 do begin
      i:= pos('$CPUMODEL$',s);
      delete(s,i,length('$CPUMODEL$'));
      insert(cpu.cpuinfo.cpuModel,s,i);
     end;

     while pos('$CPUFAMILY$',s)<>0 do begin
      i:= pos('$CPUFAMILY$',s);
      delete(s,i,length('$CPUFAMILY$'));
      insert(cpu.cpuinfo.cpuFamily,s,i);
     end;

     while pos('$TIMEZONE$',s)<>0 do begin
      i:= pos('$TIMEZONE$',s);
      delete(s,i,length('$TIMEZONE$'));
      insert(sysinfo.GetTimeZone,s,i);
     end;

     while pos('$RECENTDD$',s)<>0 do begin
      i:= pos('$RECENTDD$',s);
      delete(s,i,length('$RECENTDD$'));
      insert(sysinfo.GetMostRecentDirectDraw,s,i);
     end;

     while pos('$RECENTD3D$',s)<>0 do begin
      i:= pos('$RECENTD3D$',s);
      delete(s,i,length('$RECENTD3D$'));
      insert(sysinfo.GetMostRecentDirect3D,s,i);
     end;

     //ProzessorFhigkeiten
        while pos('$MMX$',s)<>0 do begin
         i:= pos('$MMX$',s);
         delete(s,i,length('$MMX$'));
         if copy(cpu.FeatureList[24],10,3)='YES' then insert('ja',s,i)
         else insert('nein',s,i);
        end;

        while pos('$FPU$',s)<>0 do begin
         i:= pos('$FPU$',s);
         delete(s,i,length('$FPU$'));
         if copy(cpu.FeatureList[0],9,3)='YES' then insert('ja',s,i)
         else insert('nein',s,i);
        end;

        while pos('$VME$',s)<>0 do begin
         i:= pos('$VME$',s);
         delete(s,i,length('$VME$'));
         if copy(cpu.FeatureList[1],9,3)='YES' then insert('ja',s,i)
         else insert('nein',s,i);
        end;

        while pos('$PSN$',s)<>0 do begin
         i:= pos('$PSN$',s);
         delete(s,i,length('$PSN$'));
         if copy(cpu.FeatureList[18],9,3)='YES' then insert('ja',s,i)
         else insert('nein',s,i);
        end;

        while pos('$ISSE2$',s)<>0 do begin
         i:= pos('$ISSE2$',s);
         delete(s,i,length('$ISSE2$'));
         if copy(cpu.FeatureList[26],11,3)='YES' then insert('ja',s,i)
         else insert('nein',s,i);
        end;

        while pos('$ACC$',s)<>0 do begin
         i:= pos('$ACC$',s);
         delete(s,i,length('$ACC$'));
         if copy(cpu.FeatureList[29],9,3)='YES' then insert('ja',s,i)
         else insert('nein',s,i);
        end;

        while pos('$MSR$',s)<>0 do begin
         i:= pos('$MSR$',s);
         delete(s,i,length('$MSR$'));
         if copy(cpu.FeatureList[5],9,3)='YES' then insert('ja',s,i)
         else insert('nein',s,i);
        end;

        while pos('$PAE$',s)<>0 do begin
         i:= pos('$PAE$',s);
         delete(s,i,length('$PAE$'));
         if copy(cpu.FeatureList[6],9,3)='YES' then insert('ja',s,i)
         else insert('nein',s,i);
        end;

        while pos('$APIC$',s)<>0 do begin
         i:= pos('$APIC$',s);
         delete(s,i,length('$APIC$'));
         if copy(cpu.FeatureList[9],10,3)='YES' then insert('ja',s,i)
         else insert('nein',s,i);
        end;

     if (pos('$',s)<>0) then begin   // Wenn jetzt immernoch ein $ im String ist....
       if y<= 7 then begin
        Infostrings[y].Info:=s;
        InfoStrings[y].x:=x;
        InfoStrings[y].y:=y;
        RefreshInfos;
       end
       else begin
        vfd.Bitmap.Canvas.Font.Color:=clBlack;
        vfd.Bitmap.Canvas.Font.Name:=FontLabel.Font.Name;
        vfd.Bitmap.Canvas.Font.Size:=FontLabel.Font.Size;
        vfd.Bitmap.Canvas.TextOut(x,y,s);
        Fonted:=false;
       end;
     end
     else begin                    // ....anderfalls
      if Fonted=false then vfd.PaintString(s,x,y)
      else begin
       vfd.Bitmap.Canvas.Font.Color:=clBlack;
       vfd.Bitmap.Canvas.Font.Name:=FontLabel.Font.Name;
       vfd.Bitmap.Canvas.Font.Size:=FontLabel.Font.Size;
       vfd.Bitmap.Canvas.TextOut(x,y,s);
       Fonted:=false;
      end;
     end;
end;

//Befehle - Stringinterpreter
procedure TMainForm.Interprete(s:String);
var
   p1,p2,p3,p4,p5,p6: string; //Parameter
   l: byte;  // Stringlnge
   GFX: TBitmap;
begin
     l:=length(s);

     if (s='NEWSCREEN') or (s='SCREENEND') then begin
      WaitTimer.enabled:=false;
      ExtraTimer.Enabled:=false;
      ClearInfoStrings;
  //    vfd.WriteCommand(CMD_Light_Lev1);  // volle Helligkeit
      vfd.stopClock;           // Uhr anhalten
      vfd.StopAnimation;       // Animation anhalten
      ScreenAnimated:=false;   // Voreinstellung: Screen enthlt keine Animation (kann von ANIMATION-Befehl gendert werden);
      vfd.ClearBitmap;         // Bitmapzeichenflche lschen
     end
     else if Pos('SELECTSCREEN',s)= 1 then begin
      p1:=copy(s,14,1); // Screennummer ermitteln
      vfd.SelectScreen(strtoint(p1));
     end
     else if Pos('CLEARSCREEN',s)= 1 then begin
      p1:=copy(s,13,1); // Screennummer ermitteln
      vfd.ClearScreen(strtoint(p1));
      if p1='1' then vfd.ClearBitmap; //wenn GFX_Screen gelscht wurde, auch Bitmapobjekt lschen
     end
     else if Pos('FADEOUT',s)= 1 then begin
      p1:=copy(s,9,l-8); // Geschwindigkeit ermitteln
      vfd.Fade(true, strtoint(p1));
     end
     else if Pos('FADEIN',s)= 1 then begin
      p1:=copy(s,8,l-7); // Geschwindigkeit ermitteln
      vfd.Fade(false, strtoint(p1));
     end
     else if Pos('LIGHT',s)= 1 then begin
      p1:=copy(s,7,1); // Helligkeitslevel ermitteln (einstellig)
      case strtoint(p1) of
       8: vfd.WriteCommand(CMD_Light_Lev8);
       7: vfd.WriteCommand(CMD_Light_Lev7);
       6: vfd.WriteCommand(CMD_Light_Lev6);
       5: vfd.WriteCommand(CMD_Light_Lev5);
       4: vfd.WriteCommand(CMD_Light_Lev4);
       3: vfd.WriteCommand(CMD_Light_Lev3);
       2: vfd.WriteCommand(CMD_Light_Lev2);
       1: vfd.WriteCommand(CMD_Light_Lev1);
      end;
     end
     else if Pos('CPUMONITOR',s)= 1 then begin
      CPUMONITORenabled:=true;
      showCPUMONITOR;
     end
     else if Pos('CPUMONCHAR',s)= 1 then begin
      CPUMONITORcharenabled:=true;
      showCPUMONITORchar;
     end
     else if Pos('RAMMONITOR',s)= 1 then begin
      RAMMONITORenabled:=true;
      showRAMMONITOR;
     end
     else if Pos('RAMMONCHAR',s)= 1 then begin
      RAMMONITORcharenabled:=true;
      showRAMMONITORchar;
     end
     else if Pos('PRINTERS',s)= 1 then begin
      showPrinterScreen;
     end
     else if Pos('DRIVES',s)= 1 then begin
      showDrivesScreen;
     end
     else if Pos('PAINTSTRING',s)= 1 then begin
      p3:=copy(s,l-1,2); // Y-Position
      p2:=copy(s,l-4,2); // X-Position
      p1:=copy(s,14,l-14-6);  // String zum Ausgeben
      if pos('$', p1)<>0 then begin   //Wenn der String ein Steuerzeichen '$' enthlt
       InfoString(p1,strtoint(p2),strtoint(p3));
      end else vfd.PaintString(p1,strtoint(p2),strtoint(p3));  //kein Steuerzeichen
     end
     else if Pos('TEXTOUT',s)= 1 then begin
        p6:=copy(s,10,l-8);  //'TEXTOUT ' aus s entfernen
        p5:=p6;
      p1:=copy(p6,0, (Pos('''',p5))-1 );     // Text
      p2:=copy(s,12+length(p1),3);          // XDisplay  (dreistellig)
      p3:=copy(s,16+length(p1),2);          // YDisplay  (zweistellig)
      p4:=copy(s,19+length(p1),2);          // Schrifthhe (zweistellig)
      p5:=copy(s,22+length(p1),l-28+length(p1)); //Schriftart
      if pos('$', p1)<>0 then begin   //Wenn der Text ein Steuerzeichen '$' enthlt
       FontLabel.Font.Color:=clblack;
       FontLabel.Font.Name:=p5;
       FontLabel.Font.Size:=strtoint(p4);
       Fonted:=true;
       InfoString(p1,strtoint(p2),strtoint(p3));
      end else begin
       Fonted:=false;
       vfd.Bitmap.Canvas.Font.Color:=clBlack;
       vfd.Bitmap.Canvas.Font.Name:=p5;
       vfd.Bitmap.Canvas.Font.Size:=strtoint(p4);
       vfd.Bitmap.Canvas.TextOut(strtoint(p2),strtoint(p3),p1);
      end;
     end
     else if Pos('SCREENTIME',s)= 1 then begin
      p1:=copy(s,12,l-11);
      waittimer.Interval:=strtoint(p1)*100;
      SCR_Time_Label.caption:='ScreenTime: '+floattostr(WaitTimer.Interval/1000)+ ' Sek.';
      waittimer.Enabled:=true;
     end
     else if Pos('STRETCHBITMAP',s)= 1 then begin
      p1:=copy(s,15,l-14);           //Dateiname
      gfx:=TBitmap.Create;
      gfx.Width:=256;
      gfx.Height:=64;
      gfx.LoadFromFile(p1);
      vfd.bitmap.Canvas.StretchDraw(rect(0,0,256,64),GFX);
      gfx.free;
     end
     else if Pos('ANIMATE',s)= 1 then begin
       p3:=copy(s,l-3,4);  //Speed in ms ermitteln
       p2:=copy(s,l-7,3);  //X-Position
       p1:=copy(s,9,l-17); //Filename
       vfd.Animate(p1,strtoint(p2),strtoint(p3));
      if (not PlayOnlyOnIdle) or isIdle then begin  //nur wenn isIdle oder PlayOnlyOnIdle abgeschaltet - andernfalls Befehl ignorieren
       AnimationPaused:=false;
      end else begin
       vfd.PauseAnimation;   //Animation anhalten
       AnimationPaused:=true;
      end;
      ScreenAnimated:=true;           // Screen enthlt eine Animation (relevant fr Timer)
     end
     else if Pos('PIXELBYTE',s)= 1 then begin
      p3:=copy(s,l,1);  //Letztes Zeichen= Y-Position (einstellig[0..7])
      p2:=copy(s,l-4,3);  //X-Position (dreistellig)
      p1:=copy(s,l-8,3); //Pixelbyte (dreistellig)
      vfd.SetPixelbyte(strtoint(p1),strtoint(p2),strtoint(p3));
     end
     else if Pos('TIME',s)= 1 then begin
      p2:=copy(s,l-3,4);  //Position
      p1:=copy(s,6,l-9); //Analog oder Digital?
      if p1= 'ANALOG' then vfd.Time(true, strtoint(p2))
      else vfd.time(false, strtoint(p2));
     end
     else if Pos('PAINTBITMAP',s)= 1 then begin
        p6:=copy(s,13,l-11);  //'PAINTBITMAP ' aus s entfernen
        p5:=p6;
      p1:=copy(p6,0, (Pos('?',p5))-1 );     // FileName    (? darf in Dateinamen nicht vorkommen)
      p2:=copy(s,15+length(p1),3);          // XDisplay
      p3:=copy(s,19+length(p1),1);          // YDisplay  (nur einstellig)
      p4:=copy(s,21+length(p1),3);          // Breite in Pixeln
      p5:=copy(s,25+length(p1),3);          // X-Position im Bild
      p6:=copy(s,29+length(p1),l-28+length(p1)); //MalFarbe
      BitmapToVFD(p1,strtoint(p2),strtoint(p3),strtoint(p4),strtoint(p5),stringtocolor(p6));
     end;
end;

procedure TMainForm.BitmapToVFD(fname: string; XDisp,YDisp,Wdth, XOff: word; Farbe: TColor);
var
   bm: TBitmap;
begin
     bm:=TBitmap.Create;
     bm.LoadFromFile(fname);
     vfd.PaintBitmapRect(bm,XDisp,YDisp,Wdth,XOff, Farbe);
     bm.free;
end;

procedure TMainForm.LoadList(ListFileName: TFileName);
var
   i: integer;
   s: string;
   hs: string; //Hilfsstring
   z: integer; //Hilfszhler
begin
     //Liste laden
     listbox.Items.LoadFromFile(ListFileName);

     //externe Listen einfgen
     i:=0;
     while i<= listbox.items.count-1 do begin
      s:=listbox.items[i];
      if pos('LOADSCREEN',s)=1 then begin
       hs:=copy(s,12,length(s)-11);
       ExtListBox.Items.loadfromfile(hs);
       listbox.Items.Delete(i);
       // an [i] die Strings aus ExtListBox einfgen
       for z:=ExtListBox.Items.Count-1 downto 0 do begin
        ListBox.Items.Insert(i,ExtListBox.Items[z]);
       end;
      end;

      inc(i);
     end;


     //Kommentare und Leerzeilen aus Liste entfernen
     i:=0;
     while i<= listbox.items.count-1 do begin
      s:=listbox.items[i];
      if (s='') or (s[1]=';') then begin
        listbox.items.delete(i);
        i:=i-1;
      end;
      inc(i);
     end; //while

     ListIndex:=0;
     CreateScreen;
end;


procedure TMainForm.CreateScreen;
begin
      ExtraTimer.Enabled:=false;
      CPUMONITORenabled:=false;
      CPUMONITORcharenabled:=false;
      RAMMONITORenabled:=false;
      RAMMONITORcharenabled:=false;
(*      //Infotimer-Intervall einstellen
      InfoTimer.enabled:=false;
      InfoTimer.interval:=1000;
      InfoTimer.enabled:=true;*)
      while (listbox.items[ListIndex]<>'SCREENEND') do begin
       Interprete(listbox.items[ListIndex]);
       listbox.ItemIndex:=ListIndex;
       inc(ListIndex);
      end;
end;

procedure TMainForm.WaitTimerTimer(Sender: TObject);
var
   LI: Integer;
begin
     waittimer.Enabled:=false;
     // Bei ListEnde wieder zum ListAnfang springen
     if ListIndex < ListBox.items.count-1 then inc(ListIndex)
     else ListIndex:=0;
     CreateScreen;

     // momentan ausgefhrten Block markieren
     ListBox.MultiSelect:=false;
     ListBox.MultiSelect:=true;
     LI:=ListIndex;
     listbox.selected[LI]:=true;
     while (ListBox.Items[LI]<>'NEWSCREEN') and (LI>0) do begin
      dec(LI);
      listbox.selected[LI]:=true;
     end;

end;

procedure TMainForm.ListTestButtonClick(Sender: TObject);
var
   LI: integer;
begin
     opendialog.InitialDir:=extractFileDir(application.exename)+'\Lists';
     if opendialog.Execute then begin
      WaitTimer.enabled:=false;
      StopButton.caption:='Stop';
      PopupStopButton.caption:='Stop';
      ListIndex:=0;
      LoadList(opendialog.filename);
      // momentan ausgefhrten Block (hier der erste) markieren
      ListBox.MultiSelect:=false;
      ListBox.MultiSelect:=true;
      LI:=ListIndex;
      listbox.selected[LI]:=true;
      while (ListBox.Items[LI]<>'NEWSCREEN') and (LI>0) do begin
       dec(LI);
       listbox.selected[LI]:=true;
      end;
      WaitTimer.enabled:=true;
      ToDoList:=extractfilename(opendialog.filename);
     end;
end;


//Infos, die sich stndig ndern
procedure TMainForm.RefreshInfos;
var
   z: Integer;
   i: Integer;
   s: String;
   sec: String;  //Sekunden (Winamp)
begin

     for z:=0 to 7 do begin
      s:=Infostrings[z].Info;

      if s<>'' then begin    // nur wenn auch was im string steht
        while pos('$CPUUSAGE$',s)<>0 do begin
         i:= pos('$CPUUSAGE$',s);
         delete(s,i,length('$CPUUSAGE$'));
         insert(floattostr( round(abs( cu*10) )/10),s,i);
        end;

        while pos('$FREEMEM$',s)<>0 do begin
         i:= pos('$FREEMEM$',s);
         delete(s,i,length('$FREEMEM$'));
         insert(inttostr(round(sysinfo.GetFreeMemory / 1048576)),s,i);
        end;

        while pos('$AVERAGECPU$',s)<>0 do begin
         i:= pos('$AVERAGECPU$',s);
         delete(s,i,length('$AVERAGECPU$'));
         insert(format('%f',[averageCPUusage]),s,i);
        end;

        while pos('$IP$',s)<>0 do begin
         i:= pos('$IP$',s);
         delete(s,i,length('$IP$'));
         insert(sysinfo.GetIPAdress,s,i);
        end;

        while pos('$DOW$',s)<>0 do begin
         i:= pos('$DOW$',s);
         delete(s,i,length('$DOW$'));
         insert(sysinfo.GetDayOfTheWeek,s,i);
        end;

        while pos('$UPTIME$',s)<>0 do begin
         i:= pos('$UPTIME$',s);
         delete(s,i,length('$UPTIME$'));
         insert(sysinfo.GetUptime,s ,i);
        end;
        while pos('$RES$',s)<>0 do begin
         i:= pos('$RES$',s);
         delete(s,i,length('$RES$'));
         insert(sysinfo.GetDesktopResolution,s,i);
        end;

        while pos('$COLORS$',s)<>0 do begin
         i:= pos('$COLORS$',s);
         delete(s,i,length('$COLORS$'));
         insert(sysinfo.GetDesktopColors,s,i);
        end;

        while pos('$FREQ$',s)<>0 do begin
         i:= pos('$FREQ$',s);
         delete(s,i,length('$FREQ$'));
         insert(sysinfo.GetScreenFrequency,s,i);
        end;

        while pos('$WAVERSION$',s)<>0 do begin
         i:= pos('$WAVERSION$',s);
         delete(s,i,length('$WAVERSION$'));
         if winamp.IsWinampRunning then insert(Winamp.GetVersion,s,i)
         else insert('---',s,i);
        end;

        while pos('$WATITLE$',s)<>0 do begin
         i:= pos('$WATITLE$',s);
         delete(s,i,length('$WATITLE$'));
         if winamp.IsWinampRunning then insert(Winamp.GetTrackTitle,s,i)
         else insert('---',s,i);
        end;

        while pos('$WALENGTH$',s)<>0 do begin
         i:= pos('$WALENGTH$',s);
         delete(s,i,length('$WALENGTH$'));
         if Winamp.IsWinampRunning then begin
          sec:=inttostr(winamp.GetLength mod 60);
          if length(sec)<2 then sec:='0'+sec;
          insert(inttostr(winamp.GetLength div 60)+':'+sec,s,i)
         end else insert('0:00',s,i);
        end;

        while pos('$WAPOS$',s)<>0 do begin
         i:= pos('$WAPOS$',s);
         delete(s,i,length('$WAPOS$'));
         if winamp.IsWinampRunning then begin
          sec:=inttostr( (winamp.GetOffset div 1000000)mod 60);
          if length(sec)<2 then sec:='0'+sec;
          insert(inttostr( (winamp.GetOffset div 1000000)div 60)+':'+sec,s,i)
         end else insert('0:00',s,i);
        end;

        while pos('$DATE$',s)<>0 do begin
         i:= pos('$DATE$',s);
         delete(s,i,length('$DATE$'));
         insert(datetostr(now),s,i);
        end;

        while pos('$TIME$',s)<>0 do begin
         i:= pos('$TIME$',s);
         delete(s,i,length('$TIME$'));
         insert(timetostr(now),s,i);
        end;

        while length(s)<43 do s:=s+' ';   // String bis Displayende mit Leerstellen fllen
        vfd.PaintString(s,Infostrings[z].x,Infostrings[z].y);
      end; //if s<>''
     end;  //for z
end;

procedure TMainForm.ShowExtraScreens;
const
     v0=128;
     v1=129;
     v2=130;
     v3=131;
     v4=132;
     v5=133;
     v6=134;
     v7=135;
     vs=ord(' ');
var
   i: Integer;
   Value: Integer;             //Wert in %
   PB0,PB1,PB2,PB3,PB4: Byte;  //Pixelbytes (GFX-Version)
   PB: Array[0..4] of char;    //PBs Char-Version
   s: string;
begin
     PB0:=0;
     PB1:=0;
     PB2:=0;
     PB3:=0;
     PB4:=0;

     //prfe welcher Extra-Screen gewhlt wurden

     if CPUMONITORenabled=true then begin  //grafischer CPU-Monitor
     s:='      '+floattostr(round(cu*10)/ 10)+'%';
     i:=length(s);
     vfd.paintstring(s,42-i,7);
     //Durchschnittswert oben rechts:
     s:='     '+floattostr(round(averageCPUUsage*10)/ 10)+'%';
     i:=length(s);
     vfd.paintstring(s,42-i,0);
     for i:=0 to 251 do begin
       Value:=round(CPUusage[197+i]);
       if Value<0 then Value:=1;
       //(vorheriger Wert an pos i+1)

       if Value<>0 then begin  //Null %

        //Pixelbytes berechnen
        case Value of
         0..20:  begin
                  pb4:=trunc(power(2,trunc(Value/2.5)))-1;
                  pb3:=0;
                  pb2:=0;
                  pb1:=0;
                  pb0:=0;
                 end;
         21..40: begin
                  pb3:=trunc(power(2,trunc((Value-20)/2.5)))-1;
                  Pb4:=255;
                  pb2:=0;
                  pb1:=0;
                  pb0:=0;
                 end;
         41..60: begin
                  pb2:=trunc(power(2,trunc((Value-40)/2.5)))-1;
                  Pb4:=255;
                  pb3:=255;
                  pb1:=0;
                  pb0:=0;
                 end;
         61..80: begin
                  pb1:=trunc(power(2,trunc((Value-60)/2.5)))-1;
                  Pb4:=255;
                  pb3:=255;
                  pb2:=255;
                  pb0:=0;
                 end;
         81..100: begin
                   pb0:=trunc(power(2,trunc((Value-80)/2.5)))-1;
                   Pb4:=255;
                   pb3:=255;
                   pb2:=255;
                   pb1:=255;
                  end;
        end; //case
        //Pixel setzen
        vfd.setpixelbyte(pb4,i,5);
        vfd.setpixelbyte(pb3,i,4);
        vfd.setpixelbyte(pb2,i,3);
        vfd.setpixelbyte(pb1,i,2);
        vfd.setpixelbyte(pb0,i,1);
       end //if Value <> 0
       else begin
        if i>0 then begin
          if round(CPUusage[197+i-1])>0 then vfd.setpixelbyte(0,i,5);
          if round(CPUusage[197+i-1])>20 then vfd.setpixelbyte(0,i,4);
          if round(CPUusage[197+i-1])>40 then vfd.setpixelbyte(0,i,3);
          if round(CPUusage[197+i-1])>60 then vfd.setpixelbyte(0,i,2);
          if round(CPUusage[197+i-1])>80 then vfd.setpixelbyte(0,i,1);
         end else begin
          vfd.setpixelbyte(0,i,1);
          vfd.setpixelbyte(0,i,2);
          vfd.setpixelbyte(0,i,3);
          vfd.setpixelbyte(0,i,4);
          vfd.setpixelbyte(0,i,5);
         end;
       end;  //Value =0;
     end; //for i - X-Schleife
     end //CPUMONITORenabled
     else if CPUMONITORcharenabled=true then begin       // Char-Version des CPU-Monitors (weinger CPU-Belsatung)
     vfd.paintstring('    '+floattostr(round(cu*10)/ 10)+'%',42-length('    '+floattostr(round(cu*10)/ 10)+'%'),7);
     //Durchschnittswert oben rechts:
     s:='      '+floattostr(round(averageCPUUsage*10)/ 10)+'%';
     i:=length(s);
     vfd.paintstring(s,42-i,0);

     for i:=210 to 251 do begin
       Value:=round(CPUusage[197+i]);
       if Value<0 then Value:=0;
       //(vorheriger Wert an pos i+1)

       if Value<>0 then begin  //Null %
        //Pixelbytes berechnen
        case Value of
         0..19:  begin
                  pb[4]:=chr(v0+trunc(Value/2.5));
                  pb[3]:=chr(vs);
                  pb[2]:=chr(vs);
                  pb[1]:=chr(vs);
                  pb[0]:=chr(vs);
                 end;
         20..39: begin
                  pb[3]:=chr(v0+trunc((Value-20)/2.5));
                  Pb[4]:=chr(v7);
                  pb[2]:=chr(vs);
                  pb[1]:=chr(vs);
                  pb[0]:=chr(vs);
                 end;
         40..59: begin
                  pb[2]:=chr(v0+trunc((Value-40)/2.5));
                  Pb[4]:=chr(v7);
                  pb[3]:=chr(v7);
                  pb[1]:=chr(vs);
                  pb[0]:=chr(vs);
                 end;
         60..79: begin
                  pb[1]:=chr(v0+trunc((Value-60)/2.5));
                  Pb[4]:=chr(v7);
                  pb[3]:=chr(v7);
                  pb[2]:=chr(v7);
                  pb[0]:=chr(vs);
                 end;
         80..99: begin
                   pb[0]:=chr(v0+trunc((Value-80)/2.5));
                   Pb[4]:=chr(v7);
                   pb[3]:=chr(v7);
                   pb[2]:=chr(v7);
                   pb[1]:=chr(v7);
                  end;
         100: begin
                   pb[0]:=chr(v7);
                   Pb[4]:=chr(v7);
                   pb[3]:=chr(v7);
                   pb[2]:=chr(v7);
                   pb[1]:=chr(v7);
                  end;
        end; //case
        //Pixel setzen
        vfd.Paintstring(pb[4],i-210,5);
        vfd.Paintstring(pb[3],i-210,4);
        vfd.Paintstring(pb[2],i-210,3);
        vfd.Paintstring(pb[1],i-210,2);
        vfd.Paintstring(pb[0],i-210,1);
       end //if Value <> 0
       else begin //Value = 0
        vfd.Paintstring(' ',i-210,5);
        vfd.Paintstring(' ',i-210,4);
        vfd.Paintstring(' ',i-210,3);
        vfd.Paintstring(' ',i-210,2);
        vfd.Paintstring(' ',i-210,1);
       end; //Value =0

     end; //for i - X-Schleife
     end //CPUMONITORcharenabled
     else if RAMMONITORenabled=true then begin  //grafischer RAM-Monitor
     vfd.paintstring('    '+floattostr(round(mu*10)/ 10)+'%',42-length('    '+floattostr(round(mu*10)/ 10)+'%'),7);
     for i:=0 to 251 do begin
       Value:=RAMGraph[i];
       //(vorheriger Wert an pos i+1)

       if Value<>0 then begin  //Null %

        //Pixelbytes berechnen
        case Value of
         0..20:  begin
                  pb4:=trunc(power(2,trunc(Value/2.5)))-1;
                  pb3:=0;
                  pb2:=0;
                  pb1:=0;
                  pb0:=0;
                 end;
         21..40: begin
                  pb3:=trunc(power(2,trunc((Value-20)/2.5)))-1;
                  Pb4:=255;
                  pb2:=0;
                  pb1:=0;
                  pb0:=0;
                 end;
         41..60: begin
                  pb2:=trunc(power(2,trunc((Value-40)/2.5)))-1;
                  Pb4:=255;
                  pb3:=255;
                  pb1:=0;
                  pb0:=0;
                 end;
         61..80: begin
                  pb1:=trunc(power(2,trunc((Value-60)/2.5)))-1;
                  Pb4:=255;
                  pb3:=255;
                  pb2:=255;
                  pb0:=0;
                 end;
         81..100: begin
                   pb0:=trunc(power(2,trunc((Value-80)/2.5)))-1;
                   Pb4:=255;
                   pb3:=255;
                   pb2:=255;
                   pb1:=255;
                  end;
        end; //case
        //Pixel setzen
        vfd.setpixelbyte(pb4,i,5);
        vfd.setpixelbyte(pb3,i,4);
        vfd.setpixelbyte(pb2,i,3);
        vfd.setpixelbyte(pb1,i,2);
        vfd.setpixelbyte(pb0,i,1);
       end //if Value <> 0
       else begin
        if i>0 then begin
          if RAMGraph[i-1]>0 then vfd.setpixelbyte(0,i,5);
          if RAMGraph[i-1]>20 then vfd.setpixelbyte(0,i,4);
          if RAMGraph[i-1]>40 then vfd.setpixelbyte(0,i,3);
          if RAMGraph[i-1]>60 then vfd.setpixelbyte(0,i,2);
          if RAMGraph[i-1]>80 then vfd.setpixelbyte(0,i,1);
         end else begin
          vfd.setpixelbyte(0,i,1);
          vfd.setpixelbyte(0,i,2);
          vfd.setpixelbyte(0,i,3);
          vfd.setpixelbyte(0,i,4);
          vfd.setpixelbyte(0,i,5);
         end;
       end;  //Value =0;
     end; //for i - X-Schleife
     end //RAMMONITORenabled
     else if RAMMONITORcharenabled=true then begin       // Char-Version des RAM-Monitors (weinger CPU-Belsatung)
     vfd.paintstring('    '+floattostr(round(mu*10)/ 10)+'%',42-length('    '+floattostr(round(mu*10)/ 10)+'%'),7);

     for i:=210 to 251 do begin
       Value:=RAMGraph[i];
       //(vorheriger Wert an pos i+1)

       if Value<>0 then begin  //Null %
        //Pixelbytes berechnen
        case Value of
         0..19:  begin
                  pb[4]:=chr(v0+trunc(Value/2.5));
                  pb[3]:=chr(vs);
                  pb[2]:=chr(vs);
                  pb[1]:=chr(vs);
                  pb[0]:=chr(vs);
                 end;
         20..39: begin
                  pb[3]:=chr(v0+trunc((Value-20)/2.5));
                  Pb[4]:=chr(v7);
                  pb[2]:=chr(vs);
                  pb[1]:=chr(vs);
                  pb[0]:=chr(vs);
                 end;
         40..59: begin
                  pb[2]:=chr(v0+trunc((Value-40)/2.5));
                  Pb[4]:=chr(v7);
                  pb[3]:=chr(v7);
                  pb[1]:=chr(vs);
                  pb[0]:=chr(vs);
                 end;
         60..79: begin
                  pb[1]:=chr(v0+trunc((Value-60)/2.5));
                  Pb[4]:=chr(v7);
                  pb[3]:=chr(v7);
                  pb[2]:=chr(v7);
                  pb[0]:=chr(vs);
                 end;
         80..99: begin
                   pb[0]:=chr(v0+trunc((Value-80)/2.5));
                   Pb[4]:=chr(v7);
                   pb[3]:=chr(v7);
                   pb[2]:=chr(v7);
                   pb[1]:=chr(v7);
                  end;
         100: begin
                   pb[0]:=chr(v7);
                   Pb[4]:=chr(v7);
                   pb[3]:=chr(v7);
                   pb[2]:=chr(v7);
                   pb[1]:=chr(v7);
                  end;
        end; //case
        //Pixel setzen
        vfd.Paintstring(pb[4],i-210,5);
        vfd.Paintstring(pb[3],i-210,4);
        vfd.Paintstring(pb[2],i-210,3);
        vfd.Paintstring(pb[1],i-210,2);
        vfd.Paintstring(pb[0],i-210,1);
       end //if Value <> 0
       else begin //Value = 0
        vfd.Paintstring(' ',i-210,5);
        vfd.Paintstring(' ',i-210,4);
        vfd.Paintstring(' ',i-210,3);
        vfd.Paintstring(' ',i-210,2);
        vfd.Paintstring(' ',i-210,1);
       end; //Value =0

     end; //for i - X-Schleife
     end; //RAMMONITORcharenabled
end;


procedure TMainForm.InfoTimerTimer(Sender: TObject);
begin
     //fr CPUMONITOR:
     collectcpudata;
     cu:=abs(GetCPUUsage(0)*100);
      if cu>100 then cu:=100; //man wei ja nie...
     releaseCPUdata;



     //fr RAMMONITOR:
     mu:=100-( (sysinfo.GetFreeMemory / 1048576+sysinfo.GetFreeVirtualMemory / 1048576)/(sysinfo.GetTotalMemory / 1048576+sysinfo.GetTotalVirtualMemory / 1048576)*100);

     RefreshInfos;


     //Dieser Timer sorgt auderdem dafr, da Animationen gestoppt werden, sobald
     //die durchschnittl. CPU-Last ber die IdleLevel-Grenze steigt...
     if ScreenAnimated then begin
      if PlayOnlyOnIdle and (not isIdle) and (not AnimationPaused) then begin
       vfd.PauseAnimation;
       AnimationPaused:=true;
      end;
      //... und lsst die Animation wieder weiterspielen,
      //wenn die CPU-Last wieder unter das IdleLevel fllt.
      if ((not PlayOnlyOnIdle) or isIdle) and AnimationPaused then begin
       vfd.PauseAnimation;
       AnimationPaused:=false;
      end;
     end;  //if ScreenAnimated then begin
end;

procedure TMainForm.NextButtonClick(Sender: TObject);
var
   LI: Integer;
begin
     waittimer.Enabled:=false;
     StopButton.caption:='Stop';
     PopupStopButton.caption:='Stop';
     // Bei ListEnde wieder zum ListAnfang springen
     if ListIndex < ListBox.items.count-1 then inc(ListIndex)
     else ListIndex:=0;
     CreateScreen;

     // momentan ausgefhrten Block markieren
     ListBox.MultiSelect:=false;
     ListBox.MultiSelect:=true;
     LI:=ListIndex;
     listbox.selected[LI]:=true;
     while (ListBox.Items[LI]<>'NEWSCREEN') and (LI>0) do begin
      dec(LI);
      listbox.selected[LI]:=true;
     end;
end;

procedure TMainForm.StopButtonClick(Sender: TObject);
begin
     WaitTimer.Enabled:=not WaitTimer.enabled;
     if Waittimer.enabled=true then begin
      StopButton.caption:='Stop';
      Popupstopbutton.caption:='Stop';
     end
     else begin
      StopButton.caption:='Go';
      PopupStopButton.caption:='Go';
     end; 

end;

procedure TMainForm.ViewListPanelClick(Sender: TObject);
var
   LI: Integer;
begin
     if ViewListPanel.caption='<' then begin
      MainForm.Width:=260;
      ViewListPanel.caption:='>';
     end else begin
      MainForm.Width:=630;
      ViewListPanel.caption:='<';
     end;
     Mainform.Position:=poScreenCenter;

     // momentan ausgefhrten Block markieren
     ListBox.MultiSelect:=false;
     ListBox.MultiSelect:=true;
     LI:=ListIndex;
     listbox.selected[LI]:=true;
     while (ListBox.Items[LI]<>'NEWSCREEN') and (LI>0) do begin
      dec(LI);
      listbox.selected[LI]:=true;
     end;
end;

procedure TMainForm.showCPUMONITOR;
var
   i: byte;
begin
     vfd.PaintString(chr($E8)+' CPU-Nutzung:',0,0);
     //Linie oben
     for i:=84 to 218 do
      vfd.setpixelbyte(2,i,0);
     //Linie unten
     for i:=2 to 249 do
      vfd.setpixelbyte(64,i,6);
     vfd.setpixelbyte(127,0,6);
     vfd.setpixelbyte(127,1,6);
     vfd.setpixelbyte(127,250,6);
     vfd.setpixelbyte(127,251,6);
     for i:=1 to 5 do begin
      vfd.setpixelbyte(120,i*42,6);
      vfd.setpixelbyte(120,i*42+1,6);
     end;
     vfd.setpixelbyte(127,0,6);
     vfd.setpixelbyte(127,1,6);
     vfd.setpixelbyte(127,250,6);
     vfd.setpixelbyte(127,251,6);

     vfd.PaintString(chr($60)+'vor 8   Minuten',0,7);
      // Das -Zeichen mit PixelBytes erstellen
      vfd.setpixelbyte(66,37,7);
      vfd.setpixelbyte(244,38,7);
      vfd.setpixelbyte(8,39,7);
      vfd.setpixelbyte(16,40,7);
      vfd.setpixelbyte(32,41,7);
      vfd.setpixelbyte(64,42,7);
      vfd.setpixelbyte(166,43,7);
      vfd.setpixelbyte(42,44,7);
      vfd.setpixelbyte(50,45,7);


end;

procedure TMainForm.showCPUMONITORchar;
var
   i: byte;
begin
     vfd.PaintString(chr($E9)+' CPU-Nutzung:',0,0);
     //Linie oben
     for i:=84 to 218 do
      vfd.setpixelbyte(2,i,0);
     //Linie unten
     for i:=2 to 249 do
      vfd.setpixelbyte(64,i,6);
     vfd.setpixelbyte(127,0,6);
     vfd.setpixelbyte(127,1,6);
     vfd.setpixelbyte(127,250,6);
     vfd.setpixelbyte(127,251,6);
     for i:=1 to 5 do begin
      vfd.setpixelbyte(120,i*42,6);
      vfd.setpixelbyte(120,i*42+1,6);
     end;
     vfd.setpixelbyte(127,0,6);
     vfd.setpixelbyte(127,1,6);
     vfd.setpixelbyte(127,250,6);
     vfd.setpixelbyte(127,251,6);

     vfd.PaintString(chr($60)+'vor 1   Minuten',0,7);
      // Das -Zeichen mit PixelBytes erstellen
      vfd.setpixelbyte(66,37,7);
      vfd.setpixelbyte(244,38,7);
      vfd.setpixelbyte(8,39,7);
      vfd.setpixelbyte(16,40,7);
      vfd.setpixelbyte(32,41,7);
      vfd.setpixelbyte(64,42,7);
      vfd.setpixelbyte(166,43,7);
      vfd.setpixelbyte(42,44,7);
      vfd.setpixelbyte(50,45,7);
end;

procedure TMainForm.showRAMMONITOR;
var
   i: byte;
begin
     vfd.PaintString(chr($E8)+' RAM-Nutzung:',0,0);
     //Linie oben
     for i:=84 to 251 do
      vfd.setpixelbyte(2,i,0);
     //Linie unten
     for i:=2 to 249 do
      vfd.setpixelbyte(64,i,6);
     vfd.setpixelbyte(127,0,6);
     vfd.setpixelbyte(127,1,6);
     vfd.setpixelbyte(127,250,6);
     vfd.setpixelbyte(127,251,6);
     for i:=1 to 5 do begin
      vfd.setpixelbyte(120,i*42,6);
      vfd.setpixelbyte(120,i*42+1,6);
     end;
     vfd.setpixelbyte(127,0,6);
     vfd.setpixelbyte(127,1,6);
     vfd.setpixelbyte(127,250,6);
     vfd.setpixelbyte(127,251,6);

     vfd.PaintString(chr($60)+'vor 8   Minuten',0,7);
      // Das -Zeichen mit PixelBytes erstellen
      vfd.setpixelbyte(66,37,7);
      vfd.setpixelbyte(244,38,7);
      vfd.setpixelbyte(8,39,7);
      vfd.setpixelbyte(16,40,7);
      vfd.setpixelbyte(32,41,7);
      vfd.setpixelbyte(64,42,7);
      vfd.setpixelbyte(166,43,7);
      vfd.setpixelbyte(42,44,7);
      vfd.setpixelbyte(50,45,7);


end;

procedure TMainForm.showRAMMONITORchar;
var
   i: byte;
begin
     vfd.PaintString(chr($E9)+' RAM-Nutzung:',0,0);
     //Linie oben
     for i:=84 to 251 do
      vfd.setpixelbyte(2,i,0);
     //Linie unten
     for i:=2 to 249 do
      vfd.setpixelbyte(64,i,6);
     vfd.setpixelbyte(127,0,6);
     vfd.setpixelbyte(127,1,6);
     vfd.setpixelbyte(127,250,6);
     vfd.setpixelbyte(127,251,6);
     for i:=1 to 5 do begin
      vfd.setpixelbyte(120,i*42,6);
      vfd.setpixelbyte(120,i*42+1,6);
     end;
     vfd.setpixelbyte(127,0,6);
     vfd.setpixelbyte(127,1,6);
     vfd.setpixelbyte(127,250,6);
     vfd.setpixelbyte(127,251,6);

     vfd.PaintString(chr($60)+'vor 1   Minuten',0,7);
      // Das -Zeichen mit PixelBytes erstellen
      vfd.setpixelbyte(66,37,7);
      vfd.setpixelbyte(244,38,7);
      vfd.setpixelbyte(8,39,7);
      vfd.setpixelbyte(16,40,7);
      vfd.setpixelbyte(32,41,7);
      vfd.setpixelbyte(64,42,7);
      vfd.setpixelbyte(166,43,7);
      vfd.setpixelbyte(42,44,7);
      vfd.setpixelbyte(50,45,7);
end;

procedure TMainForm.showPrinterScreen;
var
   i: integer;
   Printers: TStringList;
begin
     vfd.PaintString('Drucker:',2,0);

     //Rahmen zeichen
     vfd.PaintString(chr($98),0,0);
     vfd.PaintString(chr($99),42,0);
     vfd.PaintString(chr($9B),42,7);
     vfd.PaintString(chr($9A),0,7);
     for i:=1 to 6 do
      vfd.PaintString(chr($96),0,i);
     for i:=1 to 6 do
      vfd.PaintString(chr($96),42,i);
     for i:=1 to 41 do
      vfd.PaintString(chr($95),i,7);
     for i:=11 to 41 do
      vfd.PaintString(chr($95),i,0);

     Printers:=TStringList.create;
     sysinfo.GetPrinterInfos(Printers);
     i:=Printers.Count;
     if i>0 then begin
     vfd.PaintString(chr($F7)+' '+Printers.Strings[0],2,1);
     vfd.PaintString(Printers.Strings[1],2,2);
     vfd.PaintString(Printers.Strings[2],2,3);
      if i>4 then begin
      vfd.PaintString(chr($F7)+' '+Printers.Strings[4],2,4);
      vfd.PaintString(Printers.Strings[5],2,5);
      vfd.PaintString(Printers.Strings[6],2,6);
      end;
     end;


     Printers.free;

end;


procedure TMainForm.showDrivesScreen;
var
   i: integer;
begin
     vfd.PaintString('Laufwerke:',2,0);

     //Rahmen zeichen
     vfd.PaintString(chr($98),0,0);
     vfd.PaintString(chr($99),42,0);
     vfd.PaintString(chr($9B),42,7);
     vfd.PaintString(chr($9A),0,7);
     for i:=1 to 6 do
      vfd.PaintString(chr($96),0,i);
     for i:=1 to 6 do
      vfd.PaintString(chr($96),42,i);
     for i:=1 to 41 do
      vfd.PaintString(chr($95),i,7);
     for i:=13 to 41 do
      vfd.PaintString(chr($95),i,0);

     //Liste der Laufwerke erstellen (fr Drive-Infos)
     Drives:='';
     for i:=0 to 25 do begin
      if sysinfo.GetDriveTyp(chr(ord('A')+i))<>'nicht vorhanden' then begin
       Drives:=Drives+chr(ord('A')+i);
      end;
     end;

     ExtraTimerTimer(self);  //OnTimerEvent aktivieren, damit nicht erst bis zum ersten TimerInterval gewartet werden muss
     ExtraTimer.Enabled:=true;  //Timer aktivieren

end;

procedure TMainForm.CharBar(Xa,Xe,Line:Byte;Percent:double);
const
     Leer= $8D;
     Voll= $87;
var
   hundert: byte;
   i: byte;
begin
     hundert:=(Xe-Xa)+1;
     for i:= Xa to trunc(Xa+hundert*Percent) do
      vfd.PaintString(chr(Leer),i,Line);

     for i:=trunc(Xa+hundert*Percent)+1 to xe do
      vfd.PaintString(chr(Voll),i,Line);
end;


procedure TMainForm.ExtraTimerTimer(Sender: TObject);
var
   s: string[40];  //Hilfstring;
   TMB, FMB: double;  //TotalMBytes und FreeMBytes der Festplatte
   i: byte;
   THDS, TFHDS: extended; //TotalHardDiskSpace und TotalFreeHardDiskSpace - fr Zusammenfassung
   Laufwerke: Byte;
begin

      inc(DriveIndex);
      if DriveIndex>Length(Drives) then DriveIndex:=-1;

      if DriveIndex>0 then begin

      ExtraTimer.Enabled:=false;
      ExtraTimer.Interval:=ShowTime;  //normale Anzeigendauer
      ExtraTimer.Enabled:=true;

      //Laufwerkstyp                          ZEILE3
      s:=sysinfo.GetDriveTyp(Drives[DriveIndex]);
      while length(s)<40 do
       s:=s+' ';
      vfd.PaintString(s,2,3);

      //Volume-Bezeichnung und Laufwerksname  ZEILE2
      if sysinfo.GetDriveTyp(Drives[DriveIndex])='Festplatte' then s:=sysinfo.GetPartitionName(Drives[DriveIndex])+' ('+Drives[DriveIndex]+':)'
      else s:='('+Drives[DriveIndex]+':)';
      while length(s)<40 do
       s:=s+' ';
      vfd.PaintString(s,2,2);

      //Speicher frei/total                   ZEILE4 und ZEILE6
      if (sysinfo.GetDriveTyp(Drives[DriveIndex])='Festplatte') or (sysinfo.GetDriveTyp(Drives[DriveIndex])='RamDisk') then begin
       TMB:=GetDiskSpace(Drives[DriveIndex]);
       FMB:=GetFreeDiskSpace(Drives[DriveIndex]);
       if TMB>1024 then begin
        //Kapazitten von weniger 1GB in MB angeben, sonst in GB angeben
        TMB:=TMB/1024;
        FMB:=FMB/1024;
        s:=format('%f GB von %f GB frei  = %f',[FMB,TMB,FMB/TMB*100])+'%';
       end else s:=format('%f MB von %f BM frei  = %f',[FMB,TMB,FMB/TMB*100])+'%';
       CharBar(2,40,6,(FMB/TMB));
       while length(s)<40 do
        s:=s+' ';
       vfd.PaintString(s,2,4);
      end
      else begin
       s:='';
       while length(s)<40 do
        s:=s+' ';
       vfd.PaintString(s,2,4);
       vfd.PaintString(s,2,6);
      end;


      //                                     ZEILE5
      s:='';
      while length(s)<40 do
       s:=s+' ';
      vfd.PaintString(s,2,5);


      end
      else if DriveIndex=0 then begin  //DriveIndex=0 bedeutet Zusammenfassung

        ExtraTimer.Enabled:=false;
        ExtraTimer.Interval:=OverviewTime;  //lngere Anzeigendauer
        ExtraTimer.Enabled:=true;
        THDS:=0;
        TFHDS:=0;
        for i:=1 to length(Drives) do begin
         if sysinfo.GetDriveTyp(Drives[i])='Festplatte' then begin
          THDS:=THDS+GetDiskSpace(Drives[i])/1024;
          TFHDS:=TFHDS+GetFreeDiskSpace(Drives[i])/1024;
         end; //Festplatte
        end; //for i

        s:='Dieser Rechner hat';
        while length(s)<40 do
         s:=s+' ';
        vfd.PaintString(s,2,2);

        s:=format('%f GB Festplattenspeicher',[THDS]);
        while length(s)<40 do
         s:=s+' ';
        vfd.PaintString(s,2,3);

        s:=format('%f GB sind frei',[TFHDS]);
        while length(s)<40 do
         s:=s+' ';
        vfd.PaintString(s,2,4);

        s:=format('Insgesamt sind %f%% frei',[TFHDS/THDS*100]);
        while length(s)<40 do
         s:=s+' ';
        vfd.PaintString(s,2,5);

        CharBar(2,40,6,(TFHDS/THDS));  //CharBar bentigt den Prozentwert als 0,..-1.0 NICHT z.B. 50,6%!


      end else if DriveIndex=-1 then begin  //DriveIndex=-1 bedeutet Zusammenfassung
        ExtraTimer.Enabled:=false;
        ExtraTimer.Interval:=OverviewTime;  //lngere Anzeigendauer
        ExtraTimer.Enabled:=true;


        //Diskettenlaufwerke                        ZEILE2
        Laufwerke:=0;
        for i:=1 to length(Drives) do begin
         if sysinfo.GetDriveTyp(Drives[i])='Diskettenlaufwerk' then begin
          Laufwerke:=Laufwerke+1;
         end; //Festplatte
        end; //for i
        s:=inttostr(Laufwerke)+' Diskettenlaufwerk';
        if Laufwerke<>1 then s:=s+'e';
        while length(s)<40 do
         s:=s+' ';
        vfd.PaintString(s,2,2);

        //Festplatten                        ZEILE3
        Laufwerke:=0;
        for i:=1 to length(Drives) do begin
         if sysinfo.GetDriveTyp(Drives[i])='Festplatte' then begin
         Laufwerke:=Laufwerke+1;
         end; //Festplatte
        end; //for i
        s:=inttostr(Laufwerke)+' Festplatte';
        if Laufwerke<>1 then s:=s+'n';
        while length(s)<40 do
         s:=s+' ';
        vfd.PaintString(s,2,3);


        //CD-ROMs                            ZEILE4
        Laufwerke:=0;
        for i:=1 to length(Drives) do begin
         if sysinfo.GetDriveTyp(Drives[i])='CD-ROM' then begin
          Laufwerke:=Laufwerke+1;
         end; //Festplatte
        end; //for i
        s:=inttostr(Laufwerke)+' CD-Laufwerk';
        if Laufwerke<>1 then s:=s+'e';
        while length(s)<40 do
         s:=s+' ';
        vfd.PaintString(s,2,4);

        //Netzlaufwerke                            ZEILE5
        Laufwerke:=0;
        for i:=1 to length(Drives) do begin
         if sysinfo.GetDriveTyp(Drives[i])='Netzlaufwerk' then begin
          Laufwerke:=Laufwerke+1;
         end; //Festplatte
        end; //for i
        s:=inttostr(Laufwerke)+' Netzlaufwerk';
        if Laufwerke<>1 then s:=s+'e';
        while length(s)<40 do
         s:=s+' ';
        vfd.PaintString(s,2,5);

        //RamDisks                            ZEILE6
        Laufwerke:=0;
        for i:=1 to length(Drives) do begin
         if sysinfo.GetDriveTyp(Drives[i])='RamDisk' then begin
          Laufwerke:=Laufwerke+1;
         end; //Festplatte
        end; //for i
        s:=inttostr(Laufwerke)+' RamDisk';
        if Laufwerke<>1 then s:=s+'s';
        while length(s)<40 do
         s:=s+' ';
        vfd.PaintString(s,2,6);


      end; //else if


end;

procedure TMainForm.UsageTimerTimer(Sender: TObject);
var
   i: integer;
begin
     //Graphen aktualisieren
     //RamGraph
       for i:=0 to 251 do
     RAMGraph[i]:=RAMGraph[i+1];
     RAMGraph[252]:=round(mu);

     //CPUGraph - Durchschnittliche CPU-Last
     for i:=0 to 448 do
      CPUusage[i]:=CPUusage[i+1];
     CPUusage[449]:=cu;

     //prfe ob vorgefertigte Screen gewhlt wurden
     if CPUMONITORenabled or CPUMONITORcharenabled
     or RAMMONITORenabled or RAMMONITORcharenabled
     then ShowExtraScreens;
end;

function TMainform.averageCPUusage: single;
var
   p: Integer;
   average: single;
begin
     average:=0;
     p:=449;
     repeat
      average:=average+cpuusage[p];
      dec(p);
     until (cpuusage[p]<0) or (p<=0);

     if p<=449 then result:=average/(450-p)
     else result:=100;
end;

//berprfen, ob duchschnittliche CPU-Last whrend der IdleTime unter IdleLevel-Grenze liegt
function TMainform.isIdle: Bool;
var
   i: integer;
   average: single;
begin
     //Initialisierung:
     average:=0;
     i:=449;
     //Beispiel: - IdleTime 30 entspricht letzten 30 Messungen = 60 Sek
     //          - letzte 30 Messungen addieren und Durchschnitt berechnen
     //          - ist Durschnitt > IdleLevel ist result false
     //Hinweis:  Funktion kann nur korrekt funktionieren, wenn seit mindestens
     //          IdleTime Messdaten vorhanden sind

     while (i>=(449-IdleTime)) and (cpuusage[i]>=0) do begin
      if Cpuusage[i]>=0 then average:=average+cpuusage[i];
      dec(i);
     end;

     //Durchschnitt berechnen
     if IdleTime<>0 then begin
       if ((450-i)<IdleTime) and (i<=449) then average:=average/(450-i)  //wenn weniger Werte als IdleTime vorgibt da waren
       else if IdleTime<>0 then average:=average/(IdleTime)   //nur zur Sicherheit: Division durch Null abfangen
       else average:=100;  //Fall abfangen: i>449 and IdleTime=0
     end else average:=100;
     //IdleGrenze berschritten?
     if average<=IdleLevel then result:=true
     else result:=false;
end;

procedure TMainForm.PopupStopButtonClick(Sender: TObject);
begin
     WaitTimer.Enabled:=not WaitTimer.enabled;
     if Waittimer.enabled=true then begin
      StopButton.caption:='Go';
      PopupStopButton.caption:='Stop'
     end
     else begin
      StopButton.caption:='Go';
      PopupStopButton.caption:='Go';
     end;
end;

procedure TMainForm.NchsterScreen1Click(Sender: TObject);
begin
     NextButtonClick(self);
end;

procedure TMainForm.Listeladen1Click(Sender: TObject);
begin
     ListTestButtonClick(Self);
end;

procedure TMainForm.InfoButtonClick(Sender: TObject);
begin
     InfoForm.show;
end;

procedure TMainForm.OnlyOnIdleBoxClick(Sender: TObject);
begin
     PlayOnlyOnIdle:=OnlyOnIdleBox.Checked;
end;

procedure TMainForm.OnlyOnIdleBoxKeyPress(Sender: TObject; var Key: Char);
begin
     PlayOnlyOnIdle:=OnlyOnIdleBox.Checked;
end;

procedure TMainForm.HideTimerTimer(Sender: TObject);
begin
     Hide;

     vfd.InitVFD;
     vfd.ClearScreen(0);
     vfd.ClearScreen(1);
     HideTimer.enabled:=false; //Disabeld sich selbst

     //Liste laden
     Mainform.LoadList(extractfilepath(application.ExeName)+'Lists\'+TodoList);

end;

end.


